<script lang="ts">
  import { triggerApp } from '$world/world-store.js';
  import { drawerMenuStore } from '@svelte-common/menu/stores/drawer-menu-store.js';
  import { isMobile } from '@web-common/helpers/DeviceHelper.js';
  import { isMobileView } from '@web-common/helpers/ResponsiveHelper.js';
  import {
    inputScrollTracker,
    type InputScrollInfo,
  } from '@web-common/hooks/input-tracking/input-scroll-tracker.js';
  import { onMount } from 'svelte';
  import MobileNav from './navigation/MobileNav.svelte';
  import WebNav from './navigation/WebNav.svelte';

  let isMobileNav: boolean;
  let header: HTMLElement;

  const hide = '-100px';
  $: $triggerApp && (header.style.top = hide);
  $: $triggerApp === false && header && (header.style.top = '0');

  const onResize = () => {
    // Reset opened menu when switching environment
    // For browser device emulation
    if (isMobileNav != isMobile()) {
      drawerMenuStore.toggle(false);
    }

    // Device platform determine by device helper based on responsive width
    isMobileNav = isMobileView() || window.innerWidth < 768;
  };

  onMount(() => {
    onResize();

    const { subscribe, cleanUp } = inputScrollTracker();
    subscribe((info: InputScrollInfo) => {
      if ($triggerApp) {
        return;
      }

      $triggerApp = undefined;

      if (info.direction === 'up') {
        header.style.top = '0';
      } else {
        header.style.top = hide;
      }
    });

    return () => {
      cleanUp();
    };
  });
</script>

<svelte:window on:resize={onResize} />

<header bind:this={header}>
  <!-- If isMobileNav is undefined, don't show anything yet -->
  {#if isMobileNav !== undefined}
    {#if isMobileNav}
      <MobileNav />
    {:else}
      <WebNav />
    {/if}
  {/if}
</header>

<style lang="postcss">
  header {
    position: fixed;
    z-index: 99;
    display: flex;
    width: 100%;
    transition: top 0.3s;
  }
</style>
